Search Nearby Locations - Fabric

Search Nearby Locations

cURL

curl --request POST \
  --url 'https://api.fabric.inc/v3/locations/geography-search?limit=10' \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "filters": [
    {
      "field": "TYPE",
      "value": [
        "DC",
        "Store"
      ]
    }
  ],
  "origin": {
    "city": "San Francisco",
    "country": "United States",
    "minDistance": "0.0",
    "maxDistance": "100.0",
    "postalCode": "89135",
    "region": "New York",
    "distanceUnit": "MILE"
  }
}
'

Example Code Snippets

Python

import requests

url = "https://api.fabric.inc/v3/locations/geography-search?limit=10"

payload = {
    "filters": [
        {
            "field": "TYPE",
            "value": ["DC", "Store"]
        }
    ],
    "origin": {
        "city": "San Francisco",
        "country": "United States",
        "minDistance": "0.0",
        "maxDistance": "100.0",
        "postalCode": "89135",
        "region": "New York",
        "distanceUnit": "MILE"
    }
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    filters: [{field: 'TYPE', value: ['DC', 'Store']}],
    origin: {
      city: 'San Francisco',
      country: 'United States',
      minDistance: '0.0',
      maxDistance: '100.0',
      postalCode: '89135',
      region: 'New York',
      distanceUnit: 'MILE'
    }
  })
};

fetch('https://api.fabric.inc/v3/locations/geography-search?limit=10', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/locations/geography-search?limit=10",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'filters' => [
        [
                'field' => 'TYPE',
                'value' => [
                                'DC',
                                'Store'
                ]
        ]
    ],
    'origin' => [
        'city' => 'San Francisco',
        'country' => 'United States',
        'minDistance' => '0.0',
        'maxDistance' => '100.0',
        'postalCode' => '89135',
        'region' => 'New York',
        'distanceUnit' => 'MILE'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Expected Responses

Successful Response

{
  "pagination": {
    "limit": 10,
    "offset": 1,
    "count": 1000
  },
  "data": [
    {
      "locationNumber": 23,
      "name": "Seattle Store",
      "distance": 100,
      "locationId": "9372919a8219e8",
      "isActive": true,
      "address": {
        "region": "WA",
        "addressLine1": 123,
        "addressLine2": "Suite 100",
        "addressLine3": "Seventh floor",
        "addressLine4": "Attention: Pat E. Kake",
        "city": "Seattle",
        "countryCode": "US",
        "postalCode": 98121,
        "type": "Home",
        "contacts": [
          {
            "type": "OFFICE",
            "email": "abc@mail.com",
            "phone": [
              {
                "number": "0281923712",
                "type": "MOBILE"
              }
            ],
            "name": {
              "firstName": "Pat",
              "middleName": "E",
              "lastName": "Kake"
            }
          }
        ]
      },
      "type": "DC",
      "capacity": {
        "maxAllocations": 30,
        "currentAllocations": 5,
        "infiniteAllocation": true,
        "allocationPercentage": 20,
        "isCapacityFull": true
      },
      "services": {
        "brand": "WHBM",
        "channel": "Frontline"
      },
      "zones": ["<string>"],
      "createdAt": "2022-05-25T07:58:30.996Z",
      "updatedAt": "2022-05-25T07:58:30.996Z",
      "operatingHours": [
        {
          "day": "SUNDAY",
          "hours": [
            {
              "open": 10,
              "close": 20,
              "type": "PICK_UP"
            }
          ]
        }
      ],
      "coordinates": {
        "type": "Point",
        "coordinates": [-122.3493, 47.6205]
      },
      "attributes": {
        "isReturns": "true"
      },
      "supportedCarriers": [
        {
          "carrier": "FedEx",
          "serviceLevels": [
            {
              "name": "FedEx",
              "shippingMethod": "FedEx"
            }
          ]
        }
      ],
      "activeFulfillmentMethods": {
        "ShipToHome": "true"
      },
      "transfer": {
        "isAutoReceiving": true,
        "autoStockWindow": "PT10M"
      }
    }
  ],
  "stats": ["<string>"]
}

Error Responses

CLIENT_ERROR
{
  "type": "CLIENT_ERROR",
  "errorCode": "SERVICE-4001",
  "message": "Unauthorized request",
  "errors": [],
  "context": {
    "service": "orders",
    "endpoint": "POST /v3/orders/OrderId_12345"
  }
}
SERVER_ERROR
{
  "type": "SERVER_ERROR",
  "errorCode": "SERVICE-5000",
  "message": "Internal server error",
  "errors": [],
  "context": {
    "service": "inventories",
    "endpoint": "POST /v3/inventories/actions/find-by-geography"
  }
}

Auth and Headers

Authorization

Headers